image: gradle:8-jdk17

variables:
  NEXUS_CREDENTIALS: "-Pnexususer=$NEXUS_REPO_USER -Pnexuspass=$NEXUS_REPO_PASS"
  GIT_SUBMODULE_STRATEGY: recursive

stages:
  - test
  - build
  - deploy

test:
  stage: test
  script:
    - gradle check -x test

build:
  stage: build
  before_script:
    - export VERSION="$(gradle properties -q | awk '/^version:/ {print $2}')"
    - echo "VERSION=$VERSION" >> build.env
  script: gradle assemble
  artifacts:
    reports:
      dotenv: build.env
    paths:
      - dme-ui/build/libs/*.war
  only:
    - v4.x-master

deploy:
  stage: deploy
  script:
    - gradle clean -x test :dme-ui:publish $NEXUS_CREDENTIALS
  only:
    - deploy-apt

docs:
  stage: deploy
  script:
    - gradle clean -x test :dme-docs:publish $NEXUS_CREDENTIALS
  only:
    - docs
    
deploy-docker:
  stage: deploy
  image: docker:24.0.5
  needs:
    - build
  tags:
    - gitlab-org-docker
  services:
    - docker:24.0.5-dind
  variables:
    DOCKER_TLS_CERTDIR: "/certs"
  script:
    - docker login -u $NEXUS_REPO_USER -p $NEXUS_REPO_PASS minfba.de.dariah.eu
    - docker build -t minfba.de.dariah.eu/dme-ui:$VERSION --build-arg VERSION=$VERSION .
    - docker push minfba.de.dariah.eu/dme-ui:$VERSION
    - docker tag minfba.de.dariah.eu/dme-ui:$VERSION minfba.de.dariah.eu/dme-ui:latest
    - docker push minfba.de.dariah.eu/dme-ui:latest
  only:
    - v4.x-master
